const _cyborgBaseL=["CyborgLightBody",'CyborgLegs',0,0] 
const _cyborgBaseH=["CyborgHeavyBody",'CyborgLegs',0,0]
const _droidBase=[
    ["Body14SUP","Body13SUP","Body10MBT","Body7ABT","Body9REC","Body12SUP","Body11ABT","Body6SUPP","Body8MBT","Body5REC","Body3MBT","Body2SUP","Body4ABT","Body1REC"],
    ["tracked01",'HalfTrack','wheeled01'],0,0]
const _vtolBase=[
    ["Body14SUP","Body7ABT","Body6SUPP","Body8MBT","Body5REC","Body3MBT","Body2SUP","Body4ABT","Body1REC"],
    ["V-Tol"],0,0]

const _droidCannon=["RailGun3Mk1","RailGun2Mk1","Laser4-PlasmaCannon",'RailGun1Mk1',"Cannon6TwinAslt",'Cannon375mmMk1',"Cannon5VulcanMk1","Cannon4AUTOMk1","Cannon2A-TMk1","Cannon1Mk1","MG2Mk1","MG1Mk1"]
const _droidFlame=["Laser4-PlasmaCannon","Flame2","Flame1Mk1","MG1Mk1"]
const _droidMg=["MG5TWINROTARY","MG4ROTARYMk1","MG3Mk1","MG2Mk1","MG1Mk1"]
const _droidAA=["Missile-HvySAM","AAGunLaser","Missile-LtSAM","QuadRotAAGun","AAGun2Mk1Quad","QuadMg1AAGun","Rocket-Sunburst","AAGun2Mk1"]
const _droidBomb=["Bomb5-VTOL-Plasmite","Bomb4-VTOL-HvyINC","Bomb2-VTOL-HvHE","RailGun2-VTOL","RailGun1-VTOL","Bomb1-VTOL-LtHE","Cannon4AUTO-VTOL"]


function monoFactory(factory)
{
    var w=_droidCannon
    if (!componentAvailable(undefined,'RailGun1Mk1') && !componentAvailable(undefined,"Cannon2A-TMk1")) if (urandom()<0.8){var w=choose([_droidFlame,_droidMg,_droidMg])}
    if (componentAvailable(undefined,"V-Tol") || NeedAA>0) if (urandom()<0.3) {var w=[..._droidAA,..._droidCannon]}
    
    w=w.find(i=>componentAvailable(undefined,i))
    var w2=["RailGun3Mk1","RailGun2Mk1",'RailGun1Mk1']
    if (enumDroid(me,DROID_SENSOR).length<1 && goodCount()>0.4) if (urandom()<0.3) w="SensorTurret1Mk1"
    if (enumDroid(me,DROID_CONSTRUCT).length<8)w="Spade1Mk1"
    if (componentAvailable(undefined,"EMP-Cannon")) if (urandom()<1/3) {var w="EMP-Cannon"}
    buildDroid(factory,w,..._droidBase,w,w2)
}
function monoFactory2(factoryCyborg)
{
    var w=["Cyb-Hvywpn-RailGunner","Cyb-Wpn-Rail1","Cyb-Hvywpn-HPV","Cyb-Hvywpn-Mcannon","CyborgCannon","CyborgChaingun"].find(x=>componentAvailable(undefined,x))
    if (!(componentAvailable("Cyb-Wpn-Rail1") || componentAvailable("Cyb-Hvywpn-Mcannon")) && urandom()<0.3)w=["Cyb-Wpn-Thermite","CyborgFlamer01"].find(x=>componentAvailable(undefined,x))
    if (countDroid(DROID_CONSTRUCT,me)<4)w="CyborgSpade"
    if (w==undefined)return
    var base=_cyborgBaseL
    if (w.includes("Hvywpn"))base=_cyborgBaseH
    if (w.includes("Rail") && componentAvailable(undefined,"RailGun3Mk1"))return
    return buildDroid(factoryCyborg,w,...base,w)
}
function monoFactory3(factoryVtol)
{
    var w=_droidBomb
    var w2=w
    if (!_droidBomb.find(x=>componentAvailable(undefined,x)))return
    if (urandom()<.2 && componentAvailable(undefined,"Bomb6-VTOL-EMP"))w=["Bomb6-VTOL-EMP"]
    w=w.find(i=>componentAvailable(undefined,i))
    buildDroid(factoryVtol,w,..._vtolBase,w,w2)
}




function dumbProduction()
{
    var cyborg_factory=enumStruct(me,CYBORG_FACTORY)
    var factory=enumStruct(me,FACTORY)
    var vtol_factory=enumStruct(me,VTOL_FACTORY)

    if (playerPower(me)>100)cyborg_factory.filter(structureIdle).forEach(monoFactory2)
    if (playerPower(me)>300)factory.filter(structureIdle).forEach(monoFactory)
    if (playerPower(me)>300 && urandom()<0.2)vtol_factory.filter(structureIdle).forEach(monoFactory3) 
}

setTimer(dumbProduction.name, 703+me*3);