function goodResearch(name="",NeedAA=0)
{
    var coefDroid=countDroid(DROID_ANY,me) / getDroidLimit(me)
    var hasRail=getResearch("R-Wpn-RailGun01").started || getResearch("R-Wpn-RailGun01").done
    var hasHowitzer=getResearch("R-Wpn-HowitzerMk1").started || getResearch("R-Wpn-HowitzerMk1").done
    var cost=getResearch(name).power

    if (getResearch(name).started)return 999

    if (name.startsWith("R-Sys-Sensor-Turret"))return -100
    if (name=="R-Sys-Sensor-Tower01")return -100  
    if (name=="R-Struc-CommandRelay")return -100
    if (name=="R-Struc-Research-Module")return -100
    if (name=="R-Vehicle-Engine01")return -50
    if (name=="R-Struc-PowerModuleMk1")return -50
    if (name=="R-Wpn-Cannon1Mk1")return -40
    if (!componentAvailable(undefined,"Cannon1Mk1") & (name.startsWith("R-Wpn-MG")))return -30
    if (name=="R-Struc-Factory-Cyborg")return -20
    if (name=="R-Vehicle-Prop-Halftracks")return -15
    if (name=="R-Defense-HardcreteWall")return -10
    if (name=="R-Sys-MobileRepairTurret01")return -5
    if (name=="R-Sys-Sensor-Tower02")return 0.6

    if (name.startsWith("R-Sys-Autorepair-General"))return -100
    if (name.startsWith("R-Wpn-Rail"))return -20
    if (name.startsWith("R-Struc-Research-Upgrade"))return -10

    if (name.startsWith("R-Struc-Power"))return -.8+playerPower(me)/1500+name.endsWith("b")+name.endsWith("c")
    if (name.startsWith("R-Struc-Factory"))return 1.6-playerPower(me)/1500//+enumDroid(me).length/100

    if (name.startsWith("R-Wpn-MG3Mk1"))return 0

    if (name.startsWith("R-Wpn-Cannon-"))return 0+name.includes("Accuracy")*0.4+name.includes("ROF")*0.1+getResearch("R-Wpn-RailGun01").started+10*getResearch("R-Wpn-RailGun01").done
    if (name.startsWith("R-Cyborg-Hvywpn"))return .3
    if (name=="R-Wpn-Cannon3Mk1")return -10
    if (name.startsWith("R-Wpn-Cannon"))return 0+name.endsWith("Cannon5")*2+cost/600+getResearch("R-Wpn-PlasmaCannon").started+getResearch("R-Wpn-RailGun01").started+10*getResearch("R-Wpn-RailGun01").done

    if (name.startsWith("R-Defense-Super") || name.startsWith("R-Defense-MassDriver"))return .3-cost/800
    if (name.startsWith("R-Defense-Rail"))return .5-cost/800
    if (name.includes("AAGun"))return 1.2-componentAvailable(undefined,"V-Tol")-NeedAA
    if (name.includes("AASite"))return .5-cost-NeedAA

    if (name.startsWith("R-Vehicle-Body"))return 0.05+2*(!(name.includes("1")||name.includes("3")||name.includes("5")||name.includes("7")))-2*getResearch("R-Wpn-PlasmaCannon").done-getResearch("R-Wpn-RailGun01").started-2*getResearch("R-Wpn-RailGun01").done//|x.includes("2")|x.includes("6")|x.includes("9")
    if (name.startsWith("R-Struc-RepairFacility"))return .15
    if (name.startsWith("R-Cyborg-Metals"))return 0.1+cost/800
    if (name.startsWith("R-Vehicle-Metals"))return 0.1+cost/1000

    if (name.startsWith("R-Struc-RprFac-Upgrade"))return 2-(enumDroid(me).filter(isDamaged).length/30)+getResearch("R-Sys-Autorepair-General").done
    if (name.startsWith("R-Sys-Sensor-Upgrade"))return 1.5-name.endsWith("01")-hasRail*0.1
    if (name.startsWith("R-Vehicle-Engine"))return 2.1-2*getResearch("R-Sys-Autorepair-General").done+cost/1000
    if (name.startsWith("R-Vehicle"))return 1.8-coefDroid*0.5
    if (name.startsWith("R-Struc"))return 1.9-coefDroid*0.5
    if (name.startsWith("R-Defense-WallUpgrade"))return 1.7+cost/500
    /*
    if (name.includes("Howitzer"))return 2.3-coefDroid*0.5-hasRail
    if (name.startsWith("R-Wpn-Mortar-Damage") || (name=="R-Defense-MortarPit" || name=="R-Defense-HvyMor") )return 2.5-coefDroid*0.5-hasRail+hasHowitzer
    if (name.startsWith("R-Wpn-Mortar02Hvy"))return 2.5-coefDroid*0.5-hasHowitzer-hasRail
    */
    if (name.startsWith("R-Sys"))return Math.max(1,2-playerPower(me)/10000)

    return 6
}

const researchOverride=[]
function researchOverrideSet(researchs=[])
{
    //enumStruct(me,RESEARCH_LAB).forEach(i=>pursueResearch(i,"R-Struc-Research-Upgrade09"))
    researchOverride.splice(0,Infinity)
    researchOverride.push(...researchs)
    researchOverride.reverse()
}

var researchOverrideTry=0
function monoResearch(lab)
{
    var research=enumResearch()
    if (research.length==0)return

    if (getResearch("R-Wpn-RailGun01").done && !researchOverride.includes("R-Vehicle-Body10"))researchOverride.push("R-Vehicle-Body10")

    var labTeam=enumStruct(me,RESEARCH_LAB).sort(byBorn)
    if (labTeam.length>0 && lab.id==labTeam[0].id && (researchOverride.some(i=>!getResearch(i,me).done)))
    {
        if ((gameTime-researchOverrideTry)>1000*2)//if override no available, skip and research other
        {
            researchOverrideTry=gameTime
            return pursueResearch(lab,researchOverride)
        }
    }

    pursueResearch(lab,min(research,x=>goodResearch(x.id,NeedAA)).id)
}

function dumbResearch()
{
    var lab=enumStruct(me,RESEARCH_LAB)
    lab.filter(structureIdle).forEach(monoResearch)
}

setTimer(dumbResearch.name, 1009+me*3);