import matplotlib.pyplot as plt
import numpy as np
from math import *

x=np.linspace(-50,10,200)#np.arange(-50,10,.5)
y=np.linspace(-10,10,40)#np.arange(-10,10,.5)

def o(x):
    return np.clip(x,-1,1)

def f(x,y):
    n=5
    d=(x**2+y**2)**.5
    if d==0:return 0,0
    u=o(.5*(n-d))
    return x/d*u  ,y/d*u 

def g(x,y):
    n=5
    d=(x**2+y**2)**.5
    h=2/(1+abs(n-d))
    rad=atan2(y,x)
    return sin(-rad)*h,cos(rad)*h


xy=np.meshgrid(x,y)
xy2=np.array(np.vectorize(f)(*xy))+np.array(np.vectorize(g)(*xy))
plt.figure(figsize=(15,5))
plt.quiver(*xy2)
plt.show()