var DRange=32//Defense Range
var DTime=0//Last time enemy go through defense
var TechLevel=0//Starting Tech Level (from T0,ms)
var NeedAA=0//+1 when attacked by VTOL

include("multiplay/skirmish/EXT_DACTION.js")
include("multiplay/skirmish/dumbVector.js")
include("multiplay/skirmish/dumbLib.js")
include("multiplay/skirmish/dumbProduction.js")
include("multiplay/skirmish/dumbResearch.js")
include("multiplay/skirmish/dumbTank.js")
include("multiplay/skirmish/dumbTruck.js")
include("multiplay/skirmish/dumbVTOL.js")

function eventChat(from, to, message)
{
    if (true)//(from==me && to==me)
    {
        if (message=="q")
        {
            chat(ALL_PLAYERS,`goodCount:${goodCount()}`)
            startPositions.forEach((pos,i)=>{
                var x=enumDroid(i)
                var x2=x.filter(droid=>droid.droidType==DROID_WEAPON)
                var y=enumStruct(i)
                chat(ALL_PLAYERS,`player:${i},pos:${JSON.stringify([pos.x,pos.y])},droid:${x.length}(${x2.length}),structure:${y.length},power:${playerPower(i)}`)
            })
        }
        if (message=="w")
        {
            chat(ALL_PLAYERS,`showEnemy:`)
            hackMarkTiles()
            startPositions.forEach((pos,player)=>{
                var x=enumDroid(player)
                x.forEach(i=>hackMarkTiles(i.x,i.y,i.x+1,i.y+1))
            })
            return
        }
        if (message=="e")
        {
            chat(ALL_PLAYERS,`loopTest`)
            for (var i=0;i<1e8;i++){}
            return
        }
        if (message=="r")
        {
            chat(ALL_PLAYERS,`safeDest`)//where enemy can't see
            hackMarkTiles()
            MapTiles.forEach((arr,y)=>arr.forEach((tile,x)=>{
                if (safeDest(me,x,y))hackMarkTiles(x,y,x+1,y+1)
            }))
            return
        }

        if (message=="a")
        {
            var enemyPlayer=min( playerData.map((x,i)=>i).filter(i=>!allianceExistsBetween(me,i)), i=>-costSum(i))
            var home=startPositions[me]
            var home2=startPositions[enemyPlayer]
            var toHome=distTo(home)
            var toHome2=distTo(home2)
            var gc=goodCount()
        
            var weaponTeam=enumDroid(me).filter(droid=>droid.droidType!=DROID_CONSTRUCT).sort((a,b)=>toHome(a)-toHome(b))
            var enemyTeam=enumDroid(enemyPlayer).filter(droid=>!isVTOL(droid)).sort((a,b)=>toHome2(a)-toHome2(b))
            var enemyDroid=min(enemyTeam,distTo(home))
            var weaponTeamFront=weaponTeam.slice(weaponTeam.length*.2,Infinity)
            var enemyTeamFront=enemyTeam.slice(enemyTeam.length*.66,Infinity)
            var weaponStd=posStd(...weaponTeamFront)//the standard deviation of units
            var enemyStd=posStd(...enemyTeamFront)//the standard deviation of units
            var weaponDir=posUnify(posSub(home2,home))//the attack direction (unifyed)
            var weaponError=posLen(posMul(weaponDir,weaponStd))//error in attack direction
            var enemyError=posLen(posMul(weaponDir,enemyStd))//error in attack direction
            chat(ALL_PLAYERS,`posTest`)
            chat(ALL_PLAYERS,[weaponStd.x,weaponStd.y]) 
            chat(ALL_PLAYERS,[weaponDir.x,weaponDir.y])
            chat(ALL_PLAYERS,weaponError)
            chat(ALL_PLAYERS,enemyError)            
        }


        if (message=="r1")
        {
            chat(ALL_PLAYERS,`plasmaReasearch`)
            researchOverrideSet(["R-Wpn-PlasmaCannon","R-Defense-HvyFlamer","R-Wpn-EMPCannon"])
            return
        }
        if (message=="r2")
        {
            chat(ALL_PLAYERS,`VTOLReasearch`)
            researchOverrideSet(["R-Struc-VTOLPad","R-Wpn-Bomb02","R-Wpn-Bomb06"])
            return
        }
    }
}