function goodenemyDroid(object)
{
    if (object==undefined) return 0
    if (object.type==STRUCTURE)
    {
        switch (object.stattype) {
            case FACTORY: return -20000         
            case RESEARCH_LAB:  return -10000
            case CYBORG_FACTORY:return -5000
            case POWER_GEN:return -500        
            case OIL_RESOURCE:return -100
            default:return -object.cost
        }
    }
    if (object.type==DROID)return -object.cost
    return 0
}

function costSum(player)
{
    return sum(enumStruct(player).map(i=>i.cost))+sum(enumDroid(player).map(i=>i.cost))
}

function dumbTank()
{   
    try {var enemyPlayer=min( startPositions.map((x,i)=>i).filter(i=>!allianceExistsBetween(me,i)), i=>-costSum(i))}
    catch {return}
    var home=startPositions[me]
    var home2=startPositions[enemyPlayer]
    var toHome=distTo(home)
    var toHome2=distTo(home2)
    var gc=goodCount()

    var weaponTeam=enumDroid(me).filter(droid=>droid.droidType!=DROID_CONSTRUCT).filter(droid=>!isVTOL(droid)).sort((a,b)=>toHome(a)-toHome(b))
    var enemyTeam=enumDroid(enemyPlayer).filter(droid=>!isVTOL(droid)).sort((a,b)=>toHome2(a)-toHome2(b))
    var enemyDroid=min(enemyTeam,distTo(home))
    var weaponTeamFront=weaponTeam.slice(weaponTeam.length*.5,Infinity)
    var enemyTeamFront=enemyTeam.slice(enemyTeam.length*.5,Infinity)
    var weaponStd=posStd(...weaponTeamFront)//the standard deviation of units
    var enemyStd=posStd(...enemyTeamFront)//the standard deviation of units
    var weaponDir=posUnify(posSub(home2,home))//the attack direction (unifyed)
    var weaponError=posLen(posMul(weaponDir,weaponStd))//error in attack direction
    var enemyError=posLen(posMul(weaponDir,enemyStd))//error in attack direction


    DRange=36-(gameTime/2000)%18
    if (enumStruct(enemyDroid.player,"A0VTolFactory1").length>0)NeedAA=1

    var weaponLength=weaponTeam.length
    weaponTeam.forEach((weapon,weaponIndex)=>{
        if (weapon.order==DORDER_RECYCLE)return
        if (weapon.order==DORDER_RTR && isDamaged(weapon))
        {
            if (isJammed(weapon) && urandom()<0.05) return spamMove(weapon,5)
        }
        
        if (gc>0.95 && urandom()<0.01 && ((TechLevel+gameTime)*2/3)>(TechLevel+weapon.born))
        {return orderDroid(weapon,DORDER_RECYCLE)}

        //if spread too much in target direction, make front units back
        if (weaponError>6 && weaponIndex>weaponLength*.66 && costSum(me)<costSum(enemyPlayer)*1.5) return orderDroid(weapon,DORDER_RTB)

        //get focus-fired
        if (weapon.health<90 && weaponIndex>weaponLength*.5 && weapon.health<=min( enumRange(weapon.x,weapon.y,3,me).map(i=>i.health) ,i=>i, Infinity))
        {return orderDroid(weapon,DORDER_RTB)}

        //damaged
        if (!isSpecial(weapon) && (isDamaged(weapon)) )
        {return orderDroid(weapon,DORDER_RTR)}

        //attack in advantage or defend base
        if (distBetween(weapon,home)<DRange || (gc>0.8) || weaponError*1.5<enemyError || ((weaponTeam.length+weaponTeam.filter(i=>i.name=="Laser4-PlasmaCannon").length*5)>enemyTeam.length*1.2))
        {return spamMove(weapon,2,enemyDroid,DORDER_MOVE,8)}
        else//retreat
        {
            if (distBetween(weapon,home)>DRange)return spamMove(weapon,5,home)
            else return spamMove(weapon,3,weapon)
        }
    })
}

setTimer(dumbTank.name, 359+me*3);
